<?php
/*
Plugin Name: Google Sitemap Parser
Version: 1.0
Plugin URI: http://www.asylum-et.com/downloads/google-sitemap-parser/
Description: Display the sitemap.xml in human readable form to the sitemap page. 
For use with the Google Sitemaps plugin for wordpress found here 
http://www.arnebrachhold.de/2005/06/05/google-sitemaps-generator-v2-final.
Author: Brian Shaw
Author URI: http://www.asylum-et.com/

===========================================================================
License:
===========================================================================
 Copyright 2007  Brian C. Shaw Jr.  (email : webmaster@asylum-et.com)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
===========================================================================
*/
$check = @get_settings('siteurl'); // This makes sure that the plugin is being used right and if the page is opened directly then it does not return the infamous wordpress error
define('SMVERSION','4173796c756d2d455420536974656d617020506c7567696e2056657273696f6e20312e30');
define('GET_TAG','loc');

/* These settings should be set before activating the plugin */
define('SURL','http://archives.starbulletin.com/specials/uhvolleyball/2007/'); // Your web address
define('SMAPFILE','http://archives.starbulletin.com/specials/uhvolleyball/2007/sitemap.xml');//The path to your sitemap.xml file
define('SLINK_COUNT',20); // The number of links to output on each page so we do not have a large amount of links on the same page.
define('SURI','/sitemap/'); // This is the name of the page that you created and used the <!--sitemap--> tag in. Some installs require this to be other than /sitemap/
if(empty($check)) {exit;}// Nothing looks worse in googles index than Call to undefined function blah.....
runit($wpdb);
/* run the sitemap */
function runit($wpdb) {
  if (SURL=='http://www.your domain.com'||SMAPFILE=='http://www.your domain.com/sitemap.xml') {
  	die("Please check the asylum-et-sitemap.php definitions where it says 'These settings should be set before activating the plugin'");
  }
  add_filter('the_content', 'gen_sitemap');
}
function gen_sitemap($string_value) {
  $sm = &new site_map();
  //echo "Total link count: ".$sm->output_link_count()."<br/>";
  switch ($_GET['type']) {
  	case 'pages':
  	  $string  = "<span style=\"float:left;\"><a href=\"".$sm->uri."\">Sitemap Main</a> - Site Pages</span>";
      $string .= $sm->site_map('a');
  		break;
  	case 'blog':
  		$string  = "<span><a href=\"".$sm->uri."\">Sitemap Main</a> - Blog Posts</span>";
  		$string .= $sm->site_map('n');
  		break;
  	default:
  	  $out[] = "<p>Browse links to all pages or blog posts located on (Your Site Name)</p>\n";
  	  $out[] = "<ul>\n";
  	  $out[] = "  <li><a href=\"".$sm->uri."?type=pages\">Site Pages</a></li>\n";
  	  $out[] = "  <li><a href=\"".$sm->uri."?type=blog\">Blog Posts</a></li>\n";
  	  $out[] = "</ul>\n";
  	  $string = join('',$out);
  	  break;
  }
  // $made_by is not required but it is apreciated being that this plugin was free
  $made_by = "<p>Sitemap provided by: <a href=\"http://www.asylum-et.com/\">Asylum-ET</a></p>";
  $string_value = str_replace('<!--sitemap-->', "<!-- // ".pack("H*",SMVERSION)." -->".$string.$made_by, $string_value);
  return $string_value;
}

class site_map {
  var $get_tag = GET_TAG;
  var $url = SURL;
  var $mapfile = SMAPFILE;
  var $content;
  var $link_count = SLINK_COUNT;
  var $uri = SURI;
  function site_map($link="") {
  	$this->content = file($this->mapfile);
  	//return $this->count_linkular($this->content);
    $links = $this->parse_4_links($this->content);
	  switch ($link) {
	  	case 'a':
    	  foreach ($links['alpha'] as $a) {
        	$out[] = $a;
        }  	  		
        break;
	  	case 'n':
        foreach ($links['numeric'] as $n) {
        	$out[] = $n;
        }
        break;
	  	default:
    	  foreach ($links['alpha'] as $a) {
        	$out[] = $a;
        }
        foreach ($links['numeric'] as $n) {
        	$out[] = $n;
        }
        break;
	  }
	  if (is_numeric($_GET['page'])) {$page = $_GET['page'];} else {$page = 1;}
	  if (!empty($_GET['type'])) {
	    $type = $_GET['type'];
	    return $this->pageit($out,$page,$type);
	  }
  }
  function pageit($links,$page,$type) {
    $output_link_count = count($links);
    $num_pages =  ceil($output_link_count / $this->link_count);
    if ($output_link_count > $this->link_count) {
      /* Page Links First Previous Next and Last */
      if (($page-1)>=1) {$f = "<a href=\"".$this->uri."?type=$type&amp;page=1\">First</a>";}
      else {$f = "First";}
      if (($page-1)>=1) {$p = "<a href=\"".$this->uri."?type=$type&amp;page=".($page-1)."\">Prev</a>";}
      else {$p = "Prev";}
      if (($page+1)<=$num_pages) {$n = "<a href=\"".$this->uri."?type=$type&amp;page=".($page+1)."\">Next</a>";}
      else {$n = "Next";}
      if (($page+1)<=$num_pages) {$l = "<a href=\"".$this->uri."?type=$type&amp;page=$num_pages\">Last</a>";}
      else {$l = "Last";}
      $prenext="$f : $p : $n : $l<br/>\n";
    	$outp = "<span style=\"float:right;\">page ($page of $num_pages)</span><br/>$prenext\n";
    	if($page==1) {
    	  $link_num=($this->link_count*$page)-$this->link_count;
    	} else {
    		$link_num=($this->link_count*$page)-$this->link_count;
    	}
    	$outp .= "<ul>";
    	while ($link_num < ($this->link_count*$page)) {
    	  if(!empty($links[$link_num])) {
    	    $outp .= "<li><a href=\"".$this->url."/".$links[$link_num]."\">".$links[$link_num]."</a></li>\n";
    	  }
    		$link_num++;
    	}
    	$outp .= "</ul>";
    } else {
      //$outp = "only one page of links<br/>\n";
    	$outp = "<ul>";
      foreach ($links as $link) {
      	$outp .= "<li><a href=\"".$this->url."/".$link."\">$link</a></li>\n";
      }
    	$outp .= "</ul>";
    }
  	return $outp;
  }
  /**
   * returns the number of links in content that has been buffered from a page
   *
   * @param unknown_type $content
   * @return unknown
   */
  function count_linkular($content) {
    $num_lines = count($content);
    $i=0;
    $count=0;
    while($i<$num_lines) {
      if(preg_match('@<'.$this->get_tag.'\b[^>]*>(.*?)</'.$this->get_tag.'>@',$content[$i])==true) {
        $count++;
      }
      $i++;
    }
    return $count;
  }
  /**
   * parse the content for links
   *
   * @param unknown_type $content
   * @return unknown
   */
  function parse_4_links($content) {
    $num_lines = count($content);
    $i=0;
    while($i<$num_lines) {
      if(preg_match('@<'.$this->get_tag.'\b[^>]*>(.*?)</'.$this->get_tag.'>@',$content[$i])==true) {
        $this_link = preg_replace('@<'.$this->get_tag.'\b[^>]*>(.*?)</'.$this->get_tag.'>@', '$1', $content[$i]);
        $url = str_replace($this->url."/",'',$this_link);
        $url = str_replace($this->url,'',$url);
        $url = trim($url);
        if(!empty($url)) {$links[] = $url;}
      }
      $i++;
    }
    if(is_array($links)) {
      sort($links);
    }
    $links = $this->link_sort($links);
    return $links;
  }
  /* Sort the output */
  function link_sort($link_array) {
    foreach ($link_array as $link) {
      if(is_numeric(substr($link,0,1)) == true) {
        $links_numeric[] = $link;
      } else {
        $links_alpha[] = $link;
      }	
    }
    return array('alpha'=>$links_alpha,'numeric'=>$links_numeric);//$links;
  }
  function output_link_count() {
  	return $this->count_linkular($this->content);
  }
}
?>