<?php
/*
Plugin Name: N4R Random Posts
Plugin URI: http://www.nice4rice.com/2007/05/21/random-posts-wordpress-plugin/
Description: Returns a list of random posts.
Version: 1.00
Author: Nick Ramsay
Author URI: http://www.longcountdown.com/
*/

/*
Latest release: May 21st 2007
Copyright Nick Ramsay - Use this plugin freely, but please credit me with a link to 
http://www.nice4rice.com if you make any ammendments and redistribute it. Thanks!
*/

function n4r_random_posts($no_posts = 10, $before = '<li>', $after = '</li>') {
    global $wpdb;

	$request = "SELECT COUNT(*) FROM $wpdb->posts WHERE post_status = 'publish' AND post_type = 'post' ";
	$total_posts = $wpdb->get_var($request);
	if($total_posts < $no_posts) { $no_posts = $total_posts; }

	srand(time());

	$repeat_found = 'false';
	$i=0;
	while($i<$no_posts)
		{
        		$random[$i] = (rand()%$total_posts);
			$repeat_check = 0;
			while($repeat_check < $i)
				{
					if($random[$repeat_check] == $random[$i]) 
						{ 
							$repeat_found = 'true'; 
						}
					$repeat_check++;
				}
			if($repeat_found != 'true') 
				{ 
					$i++; 
				}
			else
				{
					$repeat_found = 'false'; 	// but don't increment $i !!
				}
		}

	$request = "SELECT ID, post_title FROM $wpdb->posts WHERE post_status = 'publish' AND post_type = 'post' ";
	$request .= "ORDER BY post_date DESC";

	$posts = $wpdb->get_results($request);
	$output = '';

	$j=0; $i=0;
    	if($posts) {
		foreach ($posts as $post) {
			while($i<$no_posts)
				{
					if($random[$i] == $j) 
						{
						$post_title = stripslashes($post->post_title);
						$permalink = get_permalink($post->ID);
						$output = $before . '<a href="' . $permalink . '" rel="bookmark" title="Permanent Link: ' . htmlspecialchars($post_title, ENT_COMPAT) . '">' . htmlspecialchars($post_title) . '</a>';
						$output .= $after;
						echo $output;
						break;
						}
					$i++;
				}
			$i=0;
			$j++;
		}
	} else {
		$output .= $before . "None found" . $after;
		echo $output;
	}
}
?>